cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

find_package(gz-rendering8 ${gz-rendering_FIND_VERSION} REQUIRED COMPONENTS ${gz-rendering_FIND_COMPONENTS})

# Set up the core library and add it to the list of all components
add_library(gz-rendering::gz-rendering ALIAS gz-rendering8::gz-rendering8)
add_library(gz-rendering::core ALIAS gz-rendering8::gz-rendering8)

# Retrieve the list of components
get_target_property(components gz-rendering8::requested INTERFACE_LINK_LIBRARIES)

foreach(component ${components})
  # Skip the core library
  if(${component} STREQUAL gz-rendering8::gz-rendering8)
    continue()
  endif()

  # Change "gz-libN::gz-libN-component" to "component"
  string(REGEX REPLACE "gz-rendering8::gz-rendering8-" "" component_name ${component})
  add_library(gz-rendering::${component_name} ALIAS ${component})
endforeach()

# Add a root gz-lib alias
add_library(gz-rendering ALIAS gz-rendering8::gz-rendering8)
